<template>
  <q-dialog ref="dialogRef" @hide="onDialogHide">
    <q-card class="q-dialog-plugin column no-wrap" style="width: 800px">
      <DefaultDialogHeader :title="title" @close="onDialogCancel" />
      <q-form ref="formRef" class="full-height scroll" @submit="onOKClick">
        <q-card-section class="row q-col-gutter-sm">
          <q-input
            v-model="form.name"
            :label="$t('common.terms.name')"
            :rules="[inputRules.required]"
            :error="!!serverErrors.name"
            :error-message="serverErrors.name"
            class="col-md-6 col-12"
            @update:model-value="serverErrors.name = null"
          />
          <q-input
            v-model="form.code"
            :label="$t('common.terms.code')"
            :rules="[inputRules.required]"
            :error="!!serverErrors.code"
            :error-message="serverErrors.code"
            class="col-md-6 col-12"
            @update:model-value="serverErrors.code = null"
          />
          <q-select
            v-model="selectedStatus"
            :label="$t('common.terms.status')"
            :options="statusOptions"
            :rules="[inputRules.required]"
            :error="!!serverErrors.status"
            :error-message="serverErrors.status"
            class="col-md-6 col-12"
            @update:model-value="serverErrors.status = null"
          />
        </q-card-section>
        <q-card-actions align="center">
          <q-btn color="primary" label="Cancel" @click="onDialogCancel" />
          <q-space />
          <q-btn
            color="primary"
            label="OK"
            :type="'submit'"
            :loading="loading"
            :disable="!hasUpdatedFields"
          />
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>
<script setup>
import { ref, useTemplateRef, onMounted, watch } from "vue";
import { useInputRules } from "src/composables/useInputRules";
import { useDialogPluginComponent } from "quasar";
import { useI18n } from "vue-i18n";
import { createCountry, updateCountry } from "src/api/country";
import { useFormUpdateTracker } from "src/composables/useFormUpdateTracker";
import { useSubmitHandler } from "src/composables/useSubmitHandler";

import DefaultDialogHeader from "src/components/defaults/DefaultDialogHeader.vue";

defineEmits([
  // REQUIRED; need to specify some events that your
  // component will emit through useDialogPluginComponent()
  ...useDialogPluginComponent.emits,
]);

const { country, title } = defineProps({
  country: {
    type: Object,
    default: null,
  },
  title: {
    type: Function,
    default: () => useI18n().t("common.terms.title"),
  },
});

const { t } = useI18n();
const { inputRules } = useInputRules();

const { dialogRef, onDialogHide, onDialogOK, onDialogCancel } =
  useDialogPluginComponent();

const formRef = useTemplateRef("formRef");

const { form, getUpdatedFields, hasUpdatedFields } = useFormUpdateTracker({
  name: country ? country?.name : "",
  code: country ? country?.code : "",
  status: country ? country?.status : "ACTIVE",
});

const {
  loading,
  serverErrors,
  execute: submitForm,
} = useSubmitHandler(() => onDialogOK(true));

const selectedStatus = ref({
  label: t("common.status.active"),
  value: "ACTIVE",
});
const statusOptions = ref([
  { label: t("common.status.active"), value: "ACTIVE" },
  { label: t("common.status.inactive"), value: "INACTIVE" },
]);

const onOKClick = async () => {
  if (!(await formRef.value.validate())) {
    return;
  }

  if (country) {
    await submitForm(() => updateCountry(getUpdatedFields.value, country.id));
  } else {
    await submitForm(() => createCountry({ ...form }));
  }
};

watch(selectedStatus, () => {
  form.status = selectedStatus.value.value;
});

onMounted(() => {
  if (country) {
    selectedStatus.value = statusOptions.value.find(
      (status) => status.value === country.status,
    );
  }
});
</script>
